#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <utility>
#include <vector>
//#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace std;

#define int long long
#define ld long double

#define mp make_pair
using ll = long long;

const int C = 550;

const int MOD = 998244389;
const int inf = 1e18;
const ld EPS = 1e-12;
const int N = 2e5 + 5;


vector<vector<int>> g(N);


void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int,int>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first;
    }
    multiset<pair<int,int>> q;
    vector<int> dist(n, inf);
    for (int i = 0; i < k; ++i) {
        q.insert({-a[i].second, a[i].first});
        dist[a[i].first] = -a[i].second;
    }
    while (!q.empty()) {
        pair<int,int> to = *q.begin();
        q.erase(q.find(to));
        int v = to.second, d = to.first;
        for (auto &i : g[v]) {
            if (d + 1 < dist[i]) {
                dist[i] = d + 1;
                q.insert({dist[i], i});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (dist[i] <= 0) ans.push_back(i + 1);
        //cout << dist[i] << ' ';
    }
//    cout << '\n';
    cout << (int)ans.size() << '\n';
    for (auto &x : ans) cout << x << ' ';

}






signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
